/**
 * @since 0.1.0
 */
import * as R from 'fp-ts/es6/Record';
import { left, right, both } from 'fp-ts/es6/These';
import { identity } from 'fp-ts/es6/function';
export function alignWith(fa, fb, f) {
    var r = {};
    for (var _i = 0, _a = Object.keys(fa); _i < _a.length; _i++) {
        var key = _a[_i];
        if (fb.hasOwnProperty(key)) {
            r[key] = f(both(fa[key], fb[key]));
        }
        else {
            r[key] = f(left(fa[key]));
        }
    }
    for (var _b = 0, _c = Object.keys(fb); _b < _c.length; _b++) {
        var key = _c[_b];
        if (!fa.hasOwnProperty(key)) {
            r[key] = f(right(fb[key]));
        }
    }
    return r;
}
export function align(fa, fb) {
    return alignWith(fa, fb, identity);
}
/**
 * @since 0.1.0
 */
export var nil = function () { return R.empty; };
