"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @since 0.1.0
 */
var Array_1 = require("fp-ts/lib/Array");
function batchTraverse(M) {
    var traverseM = Array_1.array.traverse(M);
    return function (as, f) {
        return as.reduce(function (mbs, chunk) {
            return M.chain(mbs, function (bs) {
                return M.map(traverseM(chunk, f), function (chunk) {
                    bs.push.apply(bs, chunk);
                    return bs;
                });
            });
        }, M.of([]));
    };
}
exports.batchTraverse = batchTraverse;
